P365/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.contrib import admin
from django.contrib.auth.views import logout_then_login

import calendar_year.urls
import profile.urls
import story.urls
import table.urls
import tag.urls
from map import urls_map, urls_poi, urls_route, urls_track
from profile.views import LoginView, ProfileRedirect, SignUpView, IndexView

urlpatterns = [
    # main
    path('',            IndexView.as_view(),        name='index'),
    path('admin/',      admin.site.urls,),
    path('summernote/', include('django_summernote.urls')),
    # auth
    path('login/',      LoginView.as_view(),        name='login'),
    path('register/',   SignUpView.as_view(),       name='signup'),
    path('logout/',     logout_then_login,          name='logout'),
    # redirection
    path('accounts/profile/', ProfileRedirect.as_view()),
    # tabs
    path('calendar/',   include(calendar_year.urls, namespace='calendar')),
    path('map/',        include(urls_map,           namespace='map')),
    path('table/',      include(table.urls,         namespace='table')),
    path('story/',      include(story.urls,         namespace='story')),
    # other
    path('user/',       include(profile.urls,       namespace='user')),
    path('poi/',        include(urls_poi,           namespace='poi')),
    path('route/',      include(urls_route,         namespace='route')),
    path('track/',      include(urls_track,         namespace='track')),
    path('tag/',        include(tag.urls,           namespace='tag')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

story/urls.py
from django.urls import path, register_converter

from P365.converters import UintWithoutZero
from .views import StoriesView, StoryView, StoryEditView, JSONStoryDeleteView

app_name = 'story'

register_converter(UintWithoutZero, 'uint_id')

urlpatterns = [
    path('',                          StoriesView.as_view(),         name='stories'),
    path('<uint_id:id>/',             StoryView.as_view(),           name='view'),
    path('<uint_id:id>/edit/',        StoryEditView.as_view(),       name='edit'),
    path('<uint_id:id>/json_delete/', JSONStoryDeleteView.as_view(), name='json_delete'),
    path('create/',                   StoryEditView.as_view(),       name='create'),
]

table/urls.py
from django.urls import path

from map.models import TrackModel, RouteModel, POIModel
from .views import TableView, UpdateTableView

app_name = 'table'

urlpatterns = [
    path('',                TableView.as_view(),    name='view'),
    path('update_tracks/',  UpdateTableView.as_view(), {
        'model': TrackModel,
        'template': 'partials/_tracks-table.html',
        'temp_var_name': 'tracks'},
         name='update_tracks'),
    path('update_routes/',  UpdateTableView.as_view(), {
        'model': RouteModel,
        'template': 'partials/_routes-table.html',
        'temp_var_name': 'routes'},
         name='update_routes'),
    path('update_pois/',    UpdateTableView.as_view(), {
        'model': POIModel,
        'template': 'partials/_pois-table.html',
        'temp_var_name': 'pois'},
         name='update_pois'),
]

tag/urls.py
from django.urls import path

from .views import TagCloudView, TagView

app_name = 'tag'

urlpatterns = [
    path('',                TagCloudView.as_view(), name='tag_cloud'),
    path('<slug:tagslug>/', TagView.as_view(),      name='tag'),
]

table/views.py
import mimetypes
from os.path import splitext

from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from django.contrib.gis.geos import LineString, Point
from django.http import HttpResponseRedirect
from django.shortcuts import render, get_object_or_404
from django.urls import reverse
from django.utils import timezone
from django.utils.decorators import method_decorator
from django.views import View

from google_api.elevation import get_elevation
from gpx.parser.GPXParser import GPXParser
from map.models import TrackModel, RouteModel, POIModel
from profile.models import ProfileModel


@method_decorator(login_required, name='dispatch')
class TableView(View):
    @staticmethod
    def get(request, username=None):
        if not username or username == request.user:
            profile = get_object_or_404(ProfileModel, user=request.user)
        else:
            profile = get_object_or_404(ProfileModel, user__username=username)
        user = profile.user
        pois = POIModel.objects.filter(user=user, is_active=True).order_by('-created')
        routes = RouteModel.objects.filter(user=user, is_active=True).order_by('-created')
        tracks = TrackModel.objects.filter(user=user, is_active=True).order_by('-start_date')
        return render(request, 'table.html', {
            'title':  'Table' if user == request.user else f'{username} - table',
            'active': 'table' if user == request.user else None,
            'profile': profile,
            'pois':   pois,
            'routes': routes,
            'tracks': tracks,
        })

    @staticmethod
    def post(request):
        file = request.FILES['gpx_file']
        ext, mime, size = splitext(file.name)[1][1:].lower(), mimetypes.guess_type(file.name)[0], len(file)
        if ext == 'gpx' and mime is None and size < 25 * 1024 * 1024:                   # check limits
            parser = GPXParser(file.read().decode())
            tracks, routes, pois = parser.tracks(), parser.routes(), parser.pois()
            for key, value in tracks.items():
                TrackModel(
                    name=key,
                    user=request.user,
                    start_date=timezone.make_aware(value['start_date']),
                    finish_date=timezone.make_aware(value['finish_date']),
                    length=value['length'],
                    speed=value['speed'],
                    speed_max=value['speed_max'],
                    altitude_gain=value['altitude_gain'],
                    altitude_loss=value['altitude_loss'],
                    altitude_max=value['altitude_max'],
                    altitude_min=value['altitude_min'],
                    geom=value['geom']
                ).save()
            for key, value in routes.items():
                geom = get_elevation(value['geom'])
                alts = [i[2] for i in geom]
                diffs = [alts[i] - alts[i - 1] for i in range(1, len(alts))]
                gain, loss = [i for i in diffs if i > 0], [-i for i in diffs if i < 0]
                RouteModel(
                    name=key,
                    description=value['description'],
                    user=request.user,
                    length=value['length'],
                    altitude_max=max(alts),
                    altitude_min=min(alts),
                    altitude_gain=sum(gain),
                    altitude_loss=sum(loss),
                    geom=LineString(*geom),
                ).save()
            for key, value in pois.items():
                POIModel(
                    name=key,
                    description=value['description'],
                    user=request.user,
                    geom=Point(*get_elevation(value['geom'])),
                ).save()
        return HttpResponseRedirect(reverse('table:view'))


@method_decorator(login_required, name='dispatch')
class UpdateTableView(View):
    @staticmethod
    def get(request, model, template, temp_var_name):
        order = '-start_date' if model == TrackModel else '-created'              # Tracks order by start date
        objs = model.objects.filter(user=request.user, is_active=True).order_by(order)
        return render(request, template, {temp_var_name: objs})

table/templates/table.html
{% extends "base/base.html" %}
{% load staticfiles %}

{% block content %}
<div class="card text-white bg-dark">
    <div class="progress">
        <div class="progress-bar progress-bar-striped progress-bar-animated bg-success" role="progressbar" style="width: 100%;"></div>
    </div>
    <div class="table-responsive">
        <div class="multitable">
            <ul class="nav nav-tabs">
                <li class="nav-item tracks"><a class="nav-link" href="#tracks" data-toggle="tab" role="tab" data-target="#table-tracks">Tracks</a></li>
                <li class="nav-item routes"><a class="nav-link" href="#routes" data-toggle="tab" role="tab" data-target="#table-routes">Routes</a></li>
                <li class="nav-item pois mr-auto">  <a class="nav-link" href="#pois"   data-toggle="tab" role="tab" data-target="#table-pois">POIs</a></li>
                {% if active %}
                <form class="form" method="post" enctype="multipart/form-data" action="{% url 'table:view' %}">
                    {% csrf_token %}
                    <label class="btn btn-success tab-btn">
                        <i class="fas fa-upload" aria-hidden="true"></i> Import GPX<input type="file" accept=".gpx" onchange="$('div.progress').css('display', 'flex'); this.form.submit()" hidden name="gpx_file">
                    </label>
                </form>
                <a href="{% url 'route:create' %}">
                    <button class="btn btn-success tab-btn">
                        <i class="fas fa-plus" aria-hidden="true"></i> Route
                    </button>
                </a>
                <a href="{% url 'poi:create' %}">
                    <button class="btn btn-success tab-btn">
                        <i class="fas fa-plus" aria-hidden="true"></i> POI
                    </button>
                </a>
                {% endif %}
            </ul>
            <div class="tab-content" id="tables">
                {% include 'partials/_tables.html' %}
            </div>
        </div>
    </div>
</div>
{% endblock %}

{% block css %}
<link href="{% static 'css/tables.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block js %}
<script>
    var url_track_has_story, url_track_clear_story, url_track_status, url_track_delete, url_track_update,
        url_route_status, url_route_delete, url_route_update, url_poi_status, url_poi_delete, url_poi_update;
    url_track_has_story = "{% url 'track:json_has_story' 0 %}";
    url_track_clear_story = "{% url 'track:json_clear_story' 0 %}";
    url_track_status = "{% url 'track:json_change_status' 0 %}";
    url_track_delete = "{% url 'track:json_delete' 0 %}";
    url_track_update = "{% url 'table:update_tracks' %}";
    url_route_status = "{% url 'route:json_change_status' 0 %}";
    url_route_delete = "{% url 'route:json_delete' 0 %}";
    url_route_update = "{% url 'table:update_routes' %}";
    url_poi_status = "{% url 'poi:json_change_status' 0 %}";
    url_poi_delete = "{% url 'poi:json_delete' 0 %}";
    url_poi_update = "{% url 'table:update_pois' %}";
</script>
<script src="{% static 'js/table.js' %}"></script>
{% endblock %}